console auth does not work with memcache, unicode error

Bug #1057279 reported by Sam Morrison on 2012-09-27
28
This bug affects 4 people
Affects Status Importance Assigned to Milestone
OpenStack Compute (nova)
Medium
Eugene Kirpichov
Folsom
Medium
Eugene Kirpichov
nova (Ubuntu)
Undecided
Unassigned
Quantal
Undecided
Unassigned

Bug Description

Get the following error when using console auth with memcache

2012-09-27 13:59:04 ERROR nova.openstack.common.rpc.amqp [-] Exception during message handling
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp Traceback (most recent call last):
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp File "/usr/lib/python2.7/dist-packages/nova/openstack/common/rpc/amqp.py", line 275, in _process_data
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp rval = self.proxy.dispatch(ctxt, version, method, **args)
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp File "/usr/lib/python2.7/dist-packages/nova/openstack/common/rpc/dispatcher.py", line 145, in dispatch
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp return getattr(proxyobj, method)(ctxt, **kwargs)
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp File "/usr/lib/python2.7/dist-packages/nova/consoleauth/manager.py", line 69, in authorize_console
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp self.mc.set(token, data, FLAGS.console_token_ttl)
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp File "/usr/lib/python2.7/dist-packages/memcache.py", line 565, in set
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp return self._set("set", key, val, time, min_compress_len)
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp File "/usr/lib/python2.7/dist-packages/memcache.py", line 772, in _set
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp self.check_key(key)
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp File "/usr/lib/python2.7/dist-packages/memcache.py", line 1014, in check_key
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp "Keys must be str()'s, not unicode. Convert your unicode "
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp MemcachedStringEncodingError: Keys must be str()'s, not unicode. Convert your unicode strings using mystring.encode(charset)!
2012-09-27 13:59:04 TRACE nova.openstack.common.rpc.amqp
2012-09-27 13:59:04 ERROR nova.openstack.common.rpc.common [-] Returning exception Keys must be str()'s, not unicode. Convert your unicode strings using mystring.encode(charset)! to caller
2012-09-27 13:59:04 ERROR nova.openstack.common.rpc.common [-] ['Traceback (most recent call last):\n', ' File "/usr/lib/python2.7/dist-packages/nova/openstack/common/rpc/amqp.py", line 275, in _process_data\n rval = self.proxy.dispatch(ctxt, version, method, **args)\n', ' File "/usr/lib/python2.7/dist-packages/nova/openstack/common/rpc/dispatcher.py", line 145, in dispatch\n return getattr(proxyobj, method)(ctxt, **kwargs)\n', ' File "/usr/lib/python2.7/dist-packages/nova/consoleauth/manager.py", line 69, in authorize_console\n self.mc.set(token, data, FLAGS.console_token_ttl)\n', ' File "/usr/lib/python2.7/dist-packages/memcache.py", line 565, in set\n return self._set("set", key, val, time, min_compress_len)\n', ' File "/usr/lib/python2.7/dist-packages/memcache.py", line 772, in _set\n self.check_key(key)\n', ' File "/usr/lib/python2.7/dist-packages/memcache.py", line 1014, in check_key\n "Keys must be str()\'s, not unicode. Convert your unicode "\n', "MemcachedStringEncodingError: Keys must be str()'s, not unicode. Convert your unicode strings using mystring.encode(charset)!\n"]

Changed in nova:
status: New → Confirmed
importance: Undecided → Medium
Sam Morrison (sorrison) on 2012-11-01
tags: added: folsom-backport-potential
tags: removed: folsom-backport-potential

Fix proposed to branch: master
Review: https://review.openstack.org/16804

Changed in nova:
assignee: nobody → Eugene Kirpichov (ekirpichov)
status: Confirmed → In Progress

Reviewed: https://review.openstack.org/16804
Committed: http://github.com/openstack/nova/commit/2aff4bf63ca57e0ec1290983f3109e484b95935f
Submitter: Jenkins
Branch: master

commit 2aff4bf63ca57e0ec1290983f3109e484b95935f
Author: Eugene Kirpichov <email address hidden>
Date: Thu Nov 22 14:16:25 2012 +0000

    Encode consoleauth token in utf-8 to make it a str

    Fix for lp:1057279.

    Change-Id: I9da0fd42e919aca0075613c4930ebfc3cf425349

Changed in nova:
status: In Progress → Fix Committed

Reviewed: https://review.openstack.org/16761
Committed: http://github.com/openstack/nova/commit/9c7a7116b8699475d55750f7e12b422048883f8d
Submitter: Jenkins
Branch: stable/folsom

commit 9c7a7116b8699475d55750f7e12b422048883f8d
Author: Eugene Kirpichov <email address hidden>
Date: Thu Nov 22 14:16:25 2012 +0000

    Encode consoleauth token in utf-8 to make it a str

    Fix for lp:1057279.

    Change-Id: I9da0fd42e919aca0075613c4930ebfc3cf425349

Changed in nova (Ubuntu):
status: New → Fix Released
Changed in nova (Ubuntu Quantal):
status: New → Confirmed

Hello Sam, or anyone else affected,

Accepted nova into quantal-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/nova/2012.2.1+stable-20121212-a99a802e-0ubuntu1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in nova (Ubuntu Quantal):
status: Confirmed → Fix Committed
tags: added: verification-needed
Thierry Carrez (ttx) on 2013-01-09
Changed in nova:
milestone: none → grizzly-2
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :
Download full text (8.3 KiB)

This bug was fixed in the package nova - 2012.2.1+stable-20121212-a99a802e-0ubuntu1

---------------
nova (2012.2.1+stable-20121212-a99a802e-0ubuntu1) quantal-proposed; urgency=low

  * Ubuntu updates:
    - debian/control: Ensure novaclient is upgraded with nova,
      require python-keystoneclient >= 1:2.9.0. (LP: #1073289)
    - d/p/avoid_setuptools_git_dependency.patch: Refresh.
  * Dropped patches, applied upstream:
    - debian/patches/CVE-2012-5625.patch: [a99a802]
  * Resynchronize with stable/folsom (b55014ca) (LP: #1085255):
    - [a99a802] create_lvm_image allocates dirty blocks (LP: #1070539)
    - [670b388] RPC exchange name defaults to 'openstack' (LP: #1083944)
    - [3ede373] disassociate_floating_ip with multi_host=True fails
      (LP: #1074437)
    - [22d7c3b] libvirt imagecache should handle shared image storage
      (LP: #1075018)
    - [e787786] Detached and deleted RBD volumes remain associated with insance
      (LP: #1083818)
    - [9265eb0] live_migration missing migrate_data parameter in Hyper-V driver
      (LP: #1066513)
    - [3d99848] use_single_default_gateway does not function correctly
      (LP: #1075859)
    - [65a2d0a] resize does not migrate DHCP host information (LP: #1065440)
    - [102c76b] Nova backup image fails (LP: #1065053)
    - [48a3521] Fix config-file overrides for nova-dhcpbridge
    - [69663ee] Cloudpipe in Folsom: no such option: cnt_vpn_clients
      (LP: #1069573)
    - [6e47cc8] DisassociateAddress can cause Internal Server Error
      (LP: #1080406)
    - [22c3d7b] API calls to dis-associate an auto-assigned floating IP should
      return proper warning (LP: #1061499)
    - [bd11d15] libvirt: if exception raised during volume_detach, volume state
      is inconsistent (LP: #1057756)
    - [dcb59c3] admin can't describe all images in ec2 api (LP: #1070138)
    - [78de622] Incorrect Exception raised during Create server when metadata
      over 255 characters (LP: #1004007)
    - [c313de4] Fixed IP isn't released before updating DHCP host file
      (LP: #1078718)
    - [f4ab42d] Enabling Return Reservation ID with XML create server request
      returns no body (LP: #1061124)
    - [3db2a38] 'BackupCreate' should accept rotation parameter greater than or
      equal to zero (LP: #1071168)
    - [f7e5dde] libvirt reboot sometimes fails to reattach volumes
      (LP: #1073720)
    - [ff776d4] libvirt: detaching volume may fail while terminating other
      instances on the same host concurrently (LP: #1060836)
    - [85a8bc2] Used instance uuid rather than id in remove-fixed-ip
    - [42a85c0] Fix error on invalid delete_on_termination value
    - [6a17579] xenapi migrations fail w/ swap (LP: #1064083)
    - [97649b8] attach-time field for volumes is not updated for detach volume
      (LP: #1056122)
    - [8f6a718] libvirt: rebuild is not using kernel and ramdisk associated with
      the new image (LP: #1060925)
    - [fbe835f] live-migration and volume host assignement (LP: #1066887)
    - [c2a9150] typo prevents volume_tmp_dir flag from working (LP: #1071536)
    - [93efa21] Instances deleted during spawn leak network allocations
      (LP: #1068716)
    - [ebabd02] After restartin...

Read more...

Changed in nova (Ubuntu Quantal):
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2013-04-04
Changed in nova:
milestone: grizzly-2 → 2013.1
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers